package TP2;


import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

public class JDBCServlet extends HttpServlet {

	
	private static Logger _log = null;
	private Connection dbConnection = null;
	
	String driver = null;
	String connectString = null;
	String database = null;
	String login = null;
	String password = null;
	
	public void init() throws ServletException {
		//get the path to the loggerPropertie file inside the servlet
	    String loggerProperties = this.getServletContext().getInitParameter("loggerProperties");
		loggerProperties = getServletContext().getRealPath("/") + loggerProperties;
		//load the configuration for this application's loggers using the
		// servletLog.properties file
		PropertyConfigurator.configure(loggerProperties);
		//create the logger for this servlet class
		//it will use the configuration for the logger com.java2s.LoggerServlet
		//or inherit from the logger com.java2s if one exists, and so on
		_log = Logger.getLogger(this.getClass());


		_log.info(this.getClass().getName()+" started.");
		 //display a DEBUG level message
	    _log.debug("Sending a DEBUG message");
	    //display an INFO level message
	    _log.info("Sending an INFO message");
	    //display an ERROR level message
	    _log.error("Sending an ERROR message");
	    
	    driver = this.getServletContext().getInitParameter("driver");	    
	    database = this.getInitParameter("database");
		connectString = this.getServletContext().getInitParameter("DBURL")+database;
		login = this.getServletContext().getInitParameter("login");
		password = this.getServletContext().getInitParameter("password");
		
		
	}

	public void destroy() {

	}

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws IOException {
	   
		response.setContentType("text/html");
		PrintWriter pw = response.getWriter();
		pw.print("<html>");
		pw.print("<body bgcolor=\"white\">");
		pw.print("<head>");
		pw.print("<title>Une servlet avec JDBC</title>");
		pw.print("</head>");
		pw.print("<body>");
		
		
		
		pw.print("<br/>");
		
		pw.print("<table>");
		
		
		connectAndQuery(pw);
		pw.print("</tr></table>");
		pw.print("</body>");
		pw.println("</html>");
		
		
	}

	protected void connectAndQuery(PrintWriter pw){
		try {
			Class.forName(driver);
			this.dbConnection = DriverManager.getConnection(connectString, login, password);
			String query = "SELECT * from regions";
			_log.info(query);
			Statement stmt = dbConnection.createStatement();
			pw.print("<br/>les resultats de ["+query+"] <br/>");
				
			pw.print("<table border=\"1\"><th><td>cheflieu</td><td>tncc</td><td>ncc</td> </th>");
		    ResultSet rs = stmt.executeQuery(query);
			while (rs.next()) {
					int numero = rs.getInt("region");
					String cheflieu = rs.getString("cheflieu");
		   			String ncc = rs.getString("ncc");
		   			int tncc = rs.getInt("tncc");
		   			pw.print("<tr><td>"+numero+"</td><td>"+cheflieu+"</td><td>"+tncc+"</td><td>"+ncc+"</td></tr>");
			}

				rs.close();
				stmt.close();
	
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			try{
				if (this.dbConnection != null) {
					this.dbConnection.close();
				}
			}catch (SQLException e){
				_log.info("DB connection closed with exception "+e);
			}
		}
		
		

	}
	
	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws IOException {
		doGet(request, response);
	}

	


	
	
	

}
