package TP2;


import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

public class LoginServlet extends HttpServlet {

	
	private static Logger _log = null;
	private Connection dbConnection = null;
	
	String driver = null;
	String connectString = null;
	String database = null;
	String login = null;
	String password = null;
	
	public void init() throws ServletException {
		//get the path to the loggerPropertie file inside the servlet
	    String loggerProperties = this.getServletContext().getInitParameter("loggerProperties");
		loggerProperties = getServletContext().getRealPath("/") + loggerProperties;
		//load the configuration for this application's loggers using the
		// servletLog.properties file
		PropertyConfigurator.configure(loggerProperties);
		//create the logger for this servlet class
		//it will use the configuration for the logger com.java2s.LoggerServlet
		//or inherit from the logger com.java2s if one exists, and so on
		_log = Logger.getLogger(this.getClass());


		_log.info(this.getClass().getName()+" started.");
		 //display a DEBUG level message
	    _log.debug("Sending a DEBUG message");
	    //display an INFO level message
	    _log.info("Sending an INFO message");
	    //display an ERROR level message
	    _log.error("Sending an ERROR message");
	    
	    driver = this.getServletContext().getInitParameter("driver");
	    database = this.getInitParameter("database");
		connectString = this.getServletContext().getInitParameter("DBURL")+database;
		login = this.getServletContext().getInitParameter("login");
		password = this.getServletContext().getInitParameter("password");
		
		try {
			Class.forName(driver);
			this.dbConnection = DriverManager.getConnection(connectString, login, password);
			_log.info("Opened a connectivity on DB : "+dbConnection.getMetaData().getURL());
	
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		
	}

	public void destroy() {
		try{
			if (this.dbConnection != null) {
				_log.info("Closing the connection "+dbConnection.getMetaData().getURL());

				this.dbConnection.close();
				_log.info("Closed the connection ");
			}
		}catch (SQLException e){
			_log.info("DB connection closed with exception "+e);
		}
	}

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws IOException {
	   
		response.setContentType("text/html");

		boolean exist = check(request.getParameter("login"), request.getParameter("password"));
		
		if (!exist) {
			PrintWriter pw = response.getWriter();
			pw.print("<html>");
			pw.print("<body bgcolor=\"white\">");
			pw.print("<head>");
			pw.print("<title>Une servlet pour se loguer</title>");
			pw.print("</head>");
			pw.print("<body>");
			
			String sessionID = request.getSession().getId();
			pw.print("<h1>La session</h1>");
			pw.println("<h2>session id :"+sessionID+"</h2>");

			pw.print("<h1>Liste des paramètres de requète</h1>");
			pw.print("<table border=\"1\">");
			Enumeration e = request.getParameterNames();
			while (e.hasMoreElements()){
				String param = e.nextElement().toString();
				pw.println("<tr><td>"+param+"</td><td>"+request.getParameter(param)+"</td></tr>");
			}
			pw.print("</table>");
			pw.print("<h1>Authenticate failed ! Go back to form login.xhml</h1>");
			pw.print("<table>");
			pw.print("<tr><form method=\"post\" action=\"login.xhtml\" enctype=\"text/plain\">");
			pw.print("<input type=\"submit\" onclick=\"submit\" onfocus=\"this.blur()\" value=\"Back\"/>");
			pw.print("</form>");
			pw.print("</tr></table>");
			pw.print("</body>");
			pw.println("</html>");
		} else {
			//créer ici un User et conservez le dans la session
			User u = new User ();
			u.setLogin(request.getParameter("login"));
			u.setPassword(request.getParameter("password"));
			u.setAdmin(readStatus(u.getLogin()));
			
			request.getSession(true).setAttribute("currentUser", u);
			_log.info("new user set in session "+u.toString());
			try {
				request.getRequestDispatcher("accueil.jsp").forward(request, response);
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
		
	}

	
	protected boolean check(String login, String password){
		boolean exist = false;
		try {
			String query = "SELECT * from gens where login='"+login+"' AND password='"+password+"'";
			Statement stmt = dbConnection.createStatement();
				
		    ResultSet rs = stmt.executeQuery(query);
		    
			while (rs.next()) {	
				
				exist = true;
			}

			rs.close();
			stmt.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			_log.error(e.getMessage());
		} 
		return exist;
	}
	
	protected boolean readStatus(String login){
		boolean isAdmin = false;
		try {
			String query = "SELECT * from gens where login='"+login+"'";
			Statement stmt = dbConnection.createStatement();
				
		    ResultSet rs = stmt.executeQuery(query);
			while (rs.next()) {	
				
				isAdmin = rs.getBoolean("admin");
			}

			rs.close();
			stmt.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			_log.error(e.getMessage());
		} 
		return isAdmin;
	}
	
	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws IOException {
		doGet(request, response);
	}

	


	
	
	

}
